zoj 2111 Starship Troopers(树形DP)

2023-11-08 12:08

本文主要是介绍zoj 2111 Starship Troopers(树形DP),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

1、http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=1111

2、题目大意:

题意是说有n个洞形成一棵树,你有m个士兵,每个洞都有一定数量的虫子和一定概率的首脑。每个士兵可以攻击20只虫子。而且想要攻击下面的洞的虫子,必须要攻击上层的虫子,问你花费这m个士兵,最多可以得到多少概率的首脑。

定义dp[x][y]表示在x结点放置y个士兵可以获得的brains的最大值

状态转移方程:dp[x][j]=max(dp[x][j],dp[x][j-k]+dp[v][k]);

其中dp[x][j-k]+dp[v][k]表示在x结点留下j-k个士兵,在子节点留k个士兵

因为下层的依赖于上层的结点,用dfs(_)依次调用树上的每一个结点

3、题目:

Starship Troopers

Time Limit: 5 Seconds      Memory Limit: 32768 KB

You, the leader of Starship Troopers, are sent to destroy a base of the bugs. The base is built underground. It is actually a huge cavern, which consists of many rooms connected with tunnels. Each room is occupied by some bugs, and their brains hide in some of the rooms. Scientists have just developed a new weapon and want to experiment it on some brains. Your task is to destroy the whole base, and capture as many brains as possible.

To kill all the bugs is always easier than to capture their brains. A map is drawn for you, with all the rooms marked by the amount of bugs inside, and the possibility of containing a brain. The cavern's structure is like a tree in such a way that there is one unique path leading to each room from the entrance. To finish the battle as soon as possible, you do not want to wait for the troopers to clear a room before advancing to the next one, instead you have to leave some troopers at each room passed to fight all the bugs inside. The troopers never re-enter a room where they have visited before.

A starship trooper can fight against 20 bugs. Since you do not have enough troopers, you can only take some of the rooms and let the nerve gas do the rest of the job. At the mean time, you should maximize the possibility of capturing a brain. To simplify the problem, just maximize the sum of all the possibilities of containing brains for the taken rooms. Making such a plan is a difficult job. You need the help of a computer.


Input

The input contains several test cases. The first line of each test case contains two integers N (0 < N <= 100) and M (0 <= M <= 100), which are the number of rooms in the cavern and the number of starship troopers you have, respectively. The following N lines give the description of the rooms. Each line contains two non-negative integers -- the amount of bugs inside and the possibility of containing a brain, respectively. The next N - 1 lines give the description of tunnels. Each tunnel is described by two integers, which are the indices of the two rooms it connects. Rooms are numbered from 1 and room 1 is the entrance to the cavern.

The last test case is followed by two -1's.


Output

For each test case, print on a single line the maximum sum of all the possibilities of containing brains for the taken rooms.


Sample Input

5 10
50 10
40 10
40 20
65 30
70 30
1 2
1 3
2 4
2 5
1 1
20 7
-1 -1


Sample Output


50
7

4、AC代码:

#include<stdio.h>
#include<string.h>
#include<vector>
using namespace std;
#define N 110
vector<int> vec[N];
int bugs[N];
int brains[N];
int dp[N][N];//dp[x][y]表示x结点放置y个人获得的最大brain值
int visited[N];
void dfs(int x,int m)
{visited[x]=1;int t=(bugs[x]+19)/20;//x结点至少需要的人数for(int i=t;i<=m;i++)dp[x][i]=brains[x];for(int i=0;i<vec[x].size();i++){int v=vec[x][i];if(visited[v]==0){dfs(v,m);//dp[x][j-k]+dp[v][k]表示在x结点留下j-k个士兵,在子节点留k个士兵for(int j=m;j>t;j--)//逆序可以保证用到的子节点的值时没更新的{for(int k=1;j-k>=t;k++){dp[x][j]=max(dp[x][j],dp[x][j-k]+dp[v][k]);}}}}
}
int main()
{int n,m,x,y;while(scanf("%d%d",&n,&m)!=EOF){if(n==-1 && m==-1)break;memset(visited,0,sizeof(visited));memset(dp,0,sizeof(dp));for(int i=0;i<=n;i++)vec[i].clear();for(int i=1;i<=n;i++){scanf("%d%d",&bugs[i],&brains[i]);}for(int i=1;i<n;i++){scanf("%d%d",&x,&y);vec[x].push_back(y);vec[y].push_back(x);}if(m==0)printf("0\n");else{dfs(1,m);printf("%d\n",dp[1][m]);}}return 0;
}




这篇关于zoj 2111 Starship Troopers(树形DP)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/369750

相关文章

hdu4826(三维DP)

这是一个百度之星的资格赛第四题 题目链接:http://acm.hdu.edu.cn/contests/contest_showproblem.php?pid=1004&cid=500 题意:从左上角的点到右上角的点,每个点只能走一遍,走的方向有三个:向上,向下,向右,求最大值。 咋一看像搜索题,先暴搜,TLE,然后剪枝,还是TLE.然后我就改方法,用DP来做,这题和普通dp相比,多个个向上

hdu1011(背包树形DP)

没有完全理解这题, m个人,攻打一个map,map的入口是1,在攻打某个结点之前要先攻打其他一个结点 dp[i][j]表示m个人攻打以第i个结点为根节点的子树得到的最优解 状态转移dp[i][ j ] = max(dp[i][j], dp[i][k]+dp[t][j-k]),其中t是i结点的子节点 代码如下: #include<iostream>#include<algorithm

hdu4865(概率DP)

题意:已知前一天和今天的天气概率,某天的天气概率和叶子的潮湿程度的概率,n天叶子的湿度,求n天最有可能的天气情况。 思路:概率DP,dp[i][j]表示第i天天气为j的概率,状态转移如下:dp[i][j] = max(dp[i][j, dp[i-1][k]*table2[k][j]*table1[j][col] )  代码如下: #include <stdio.h>#include

usaco 1.1 Broken Necklace(DP)

直接上代码 接触的第一道dp ps.大概的思路就是 先从左往右用一个数组在每个点记下蓝或黑的个数 再从右到左算一遍 最后取出最大的即可 核心语句在于: 如果 str[i] = 'r'  ,   rl[i]=rl[i-1]+1, bl[i]=0 如果 str[i] = 'b' ,  bl[i]=bl[i-1]+1, rl[i]=0 如果 str[i] = 'w',  bl[i]=b

uva 10154 DP 叠乌龟

题意: 给你几只乌龟,每只乌龟有自身的重量和力量。 每只乌龟的力量可以承受自身体重和在其上的几只乌龟的体重和内。 问最多能叠放几只乌龟。 解析: 先将乌龟按力量从小到大排列。 然后dp的时候从前往后叠,状态转移方程: dp[i][j] = dp[i - 1][j];if (dp[i - 1][j - 1] != inf && dp[i - 1][j - 1] <= t[i]

uva 10118 dP

题意: 给4列篮子,每次从某一列开始无放回拿蜡烛放入篮子里,并且篮子最多只能放5支蜡烛,数字代表蜡烛的颜色。 当拿出当前颜色的蜡烛在篮子里存在时,猪脚可以把蜡烛带回家。 问最多拿多少只蜡烛。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cs

uva 10069 DP + 大数加法

代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <stack>#include <vector>#include <queue>#include <map>#include <cl

uva 10029 HASH + DP

题意: 给一个字典,里面有好多单词。单词可以由增加、删除、变换,变成另一个单词,问能变换的最长单词长度。 解析: HASH+dp 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#inc

XTU 1233 n个硬币连续m个正面个数(dp)

题面: Coins Problem Description: Duoxida buys a bottle of MaiDong from a vending machine and the machine give her n coins back. She places them in a line randomly showing head face or tail face o

dp算法练习题【8】

不同二叉搜索树 96. 不同的二叉搜索树 给你一个整数 n ,求恰由 n 个节点组成且节点值从 1 到 n 互不相同的 二叉搜索树 有多少种?返回满足题意的二叉搜索树的种数。 示例 1: 输入:n = 3输出:5 示例 2: 输入:n = 1输出:1 class Solution {public int numTrees(int n) {int[] dp = new int